<?php
/*---------------------------------------------------+
| PHP-Fusion 6 Content Management System
+----------------------------------------------------+
| Copyright  2002 - 2005 Nick Jones
| http://www.php-fusion.co.uk/
+----------------------------------------------------+
| MusicBox v1.1
| Copyright (c) 2006 Gander
| http://www.gander.pl/
+----------------------------------------------------+
| Released under the terms & conditions of v2 of the
| GNU General Public License. For details refer to
| the included gpl.txt file or visit http://gnu.org
+----------------------------------------------------*/
require_once "../../maincore.php";
require_once BASEDIR."subheader.php";
require_once ADMIN."navigation.php";

if (!checkrights("IP") || !defined("iAUTH") || $aid != iAUTH) fallback("../index.php");
if (!isset($step)) $step = "";

if (file_exists(INFUSIONS."musicbox_panel/locale/".$settings['locale'].".php")) {
	include INFUSIONS."musicbox_panel/locale/".$settings['locale'].".php";
} else {
	include INFUSIONS."musicbox_panel/locale/English.php";
}

// Jesli wcisnieto guzik anulowania
if (isset($_POST['cancel_button'])){
	redirect(FUSION_SELF.$aidlink);
	exit;
}

// Zapisywanie ustawien
if (isset($_POST['save_settings'])){
	$description = addslash(trim($_POST['description']));
	$enable_autostart = ($_POST['enable_autostart'] == "yes" ? 1 : 0);
	$enable_loop = ($_POST['enable_loop'] == "yes" ? 1 : 0);
	dbquery("UPDATE ".$db_prefix."musicbox_settings SET description='$description', enable_autostart='$enable_autostart', enable_loop='$enable_loop'");
	redirect(FUSION_SELF.$aidlink);
	exit;
}

// Kasowanie sciezek
if (isset($_POST['delete'])){
	foreach($_POST['tracks'] as $key => $value) dbquery("DELETE FROM ".$db_prefix."musicbox_tracks WHERE track_id = '".$_POST['tracks'][$key]."'");
	redirect(FUSION_SELF.$aidlink."&step=refresh");
	exit;
}

// Generowanie pliku playlisty
if (isset($_POST['generate'])){
	$tracks = array();
	foreach($_POST['tracks'] as $key => $value) $tracks[] = $_POST['tracks'][$key];
	if (count($tracks)){
		$result = dbquery("SELECT track_file FROM ".$db_prefix."musicbox_tracks WHERE track_id IN (".implode($tracks,",").") ORDER BY track_order ASC");
		if (dbrows($result)){
			$text = "<?xml version=\"1.0\" encoding=\"ISO-8859-2\" ?>\r\n";
			$text .= "<!DOCTYPE playlist SYSTEM \"http://www.webminster.de/ext/xml/webplayer/playlist.dtd\">\r\n";
			$text .= "<playlist name=\"\" basedir=\"\" xmlns=\"http://www.webminster.de/ext/xml/webplayer\">\r\n";
			while($data = dbarray($result)){
				$text .= "\t<file src=\"".$data['track_file']."\" />\r\n";
			}
			$text .= "</playlist>\r\n";
	
			$temp = fopen("playlist.xml","w");
			fwrite($temp, $text);
			fclose($temp);
		}
	}
	redirect(FUSION_SELF.$aidlink);
	exit;
}

// Zapisywanie sciezki
if ($step == "save"){
	$track_title = stripinput(trim($_POST['track_title'][0]));
	$track_file = trim(strip_tags(str_replace("\\\\", "/", $_POST['track_file'][0])));
	if (preg_match("/^[-0-9A-Z_ \.\s]+$/i",$track_title) && preg_match("/^[-0-9A-Z_\~\:\/\.]+$/i",$track_file)){
		$track_order = dbresult(dbquery("SELECT max( track_order ) FROM ".$db_prefix."musicbox_tracks"), 0) + 1;
		dbquery("INSERT INTO ".$db_prefix."musicbox_tracks (track_title,track_file,track_order) VALUES ('".$track_title."','".$track_file."','".$track_order."')");
	}
	redirect(FUSION_SELF.$aidlink);
	exit;
}

// Aktualizacja sciezek
if ($step == "update"){
	foreach($_POST['track_id'] as $key => $value) {
		$track_id = $_POST['track_id'][$key];
		$track_title = stripinput(trim(strip_tags($_POST['track_title'][$key])));
		$track_file = trim(strip_tags(str_replace("\\\\", "/", $_POST['track_file'][$key])));
		if (isNum($track_id) && preg_match("/^[-0-9A-Z_\.\s]+$/i",$track_title) && preg_match("/^[-0-9A-Z_\:\/\.]+$/i",$track_file)){
			dbquery("UPDATE ".$db_prefix."musicbox_tracks SET track_title='".$track_title."', track_file='".$track_file."' WHERE track_id = '".$track_id."'");
		}
	}
	redirect(FUSION_SELF.$aidlink);
	exit;
}

// Aktualizacja kolejnosci sciezek
if ($step == "refresh") {
	$i = 1;
	$result = dbquery("SELECT track_id FROM ".$db_prefix."musicbox_tracks ORDER BY track_order ASC");
	while ($data = dbarray($result)) {
		dbquery("UPDATE ".$db_prefix."musicbox_tracks SET track_order='".($i++)."' WHERE track_id='".$data['track_id']."'");
	}
	redirect(FUSION_SELF.$aidlink);
	exit;
}

if ($step == "mup") { // Przesuniecie w gore
	$data = dbarray(dbquery("SELECT * FROM ".$db_prefix."musicbox_tracks WHERE track_order='$order'"));
	$result = dbquery("UPDATE ".$db_prefix."musicbox_tracks SET track_order=track_order+1 WHERE track_id='".$data['track_id']."'");
	$result = dbquery("UPDATE ".$db_prefix."musicbox_tracks SET track_order=track_order-1 WHERE track_id='$track_id'");
	redirect(FUSION_SELF.$aidlink);
	exit;
}

if ($step == "mdown") { // Przesuniecie w dol
	$data = dbarray(dbquery("SELECT * FROM ".$db_prefix."musicbox_tracks WHERE track_order='$order'"));
	$result = dbquery("UPDATE ".$db_prefix."musicbox_tracks SET track_order=track_order-1 WHERE track_id='".$data['track_id']."'");
	$result = dbquery("UPDATE ".$db_prefix."musicbox_tracks SET track_order=track_order+1 WHERE track_id='$track_id'");
	redirect(FUSION_SELF.$aidlink);
	exit;
}


// Wczytywanie ustawien
$mb_settings = dbarray(dbquery("SELECT * FROM ".$db_prefix."musicbox_settings"));

// Informacje
echo "<!--
MusicBox v1.1
Author: Gander
Visit: www.gander.pl

WebPlayer v2.0.1
Author: WebMinster
Visit: http://www.webminster.de/webplayer/
-->\n";

opentable($locale['mbp200']); // Ustawienia
echo "<center>
<form name='settings_form' action='".FUSION_SELF.$aidlink."' method='post'>
<table cellpadding='0' cellspacing='0'>
<tr>
	<td class='tbl' rowspan='2'>".$locale['mbp202']."</td>
	<td class='tbl' rowspan='2'><textarea name='description' class='textbox' rows='2' cols='30'>".stripinput($mb_settings['description'])."</textarea></td>
	<td class='tbl'><input type='checkbox' class='poll' name='enable_autostart' value='yes'".($mb_settings['enable_autostart'] ? " checked" : "")."></td>
	<td class='tbl'>AutoStart</td>
	<td class='tbl' rowspan='2'><input type='submit' name='save_settings' class='button' value='".$locale['mbp203']."'></td>
</tr>
<tr>
	<td class='tbl'><input type='checkbox' class='poll' name='enable_loop' value='yes'".($mb_settings['enable_loop'] ? " checked" : "")."></td>
	<td class='tbl'>Loop</td>
</tr>
</table>
</form>
</center>\n";
closetable();

tablebreak();

opentable($locale['mbp204']); // Sciezki
echo "<center>\n";
$result = dbquery("SELECT * FROM ".$db_prefix."musicbox_tracks ORDER BY track_order ASC");
$numrows = dbrows($result);
if ($numrows){
	$i = 0; $j = 1;
	echo"<form name='tracks_form' action='".FUSION_SELF.$aidlink."' method='post' onSubmit=\"return isAnyChecked('tracks_form','tracks[]');\">
<table cellpadding='0' cellspacing='1' class='tbl-border' width='80%'>\n";
	while($data = dbarray($result)){
		if ($numrows != 1) {
			$up = $data['track_order'] - 1;
			$down = $data['track_order'] + 1;
			if ($j == 1) {
				$up_down = " <a href='".FUSION_SELF.$aidlink."&amp;step=mdown&amp;track_id=".$data['track_id']."&amp;order=$down'><img src='".THEME."images/down.gif' alt='&darr;' title='".$locale['mbp205']."' style='border:0px;'></a>";
			} else if ($j < $numrows) {
				$up_down = " <a href='".FUSION_SELF.$aidlink."&amp;step=mup&amp;track_id=".$data['track_id']."&amp;order=$up'><img src='".THEME."images/up.gif' alt='&uarr;' title='".$locale['mbp206']."' style='border:0px;'></a>\n";
				$up_down .= " <a href='".FUSION_SELF.$aidlink."&amp;step=mdown&amp;track_id=".$data['track_id']."&amp;order=$down'><img src='".THEME."images/down.gif' alt='&darr;' title='".$locale['mbp205']."' style='border:0px;'></a>";
			} else {
				$up_down = " <a href='".FUSION_SELF.$aidlink."&amp;step=mup&amp;track_id=".$data['track_id']."&amp;order=$up'><img src='".THEME."images/up.gif' alt='&uarr;' title='".$locale['mbp206']."' style='border:0px;'></a>";
			}
		} else {
			$up_down = "";
		}
		echo "<tr>
<td class='tbl2' width='1%' align='center'>".($j++)."</td>
<td class='tbl2' width='1%'><input type='checkbox' name='tracks[]' value='".$data['track_id']."' id='field_$i' class='poll'></td>		
<td class='tbl2'><a href='#' title='".$locale['mbp207']."' onClick='alert(\"".$data['track_file']."\");'>[url]</a> <label for='field_$i'>".$data['track_title']."</label></td>		
<td class='tbl2' width='1%' align='center' nowrap>".$up_down."</td>
</tr>\n";
		$i++;
	}
	echo "<tr>
<td class='tbl2' colspan='2' align='center' nowrap>
<button class='button' style='width:16px;' title='".$locale['mbp208']."' onClick=\"javascript:setChecked('tracks_form','tracks[]',1);return false;\">+</button>
<button class='button' style='width:15px;' title='".$locale['mbp209']."' onClick=\"javascript:setChecked('tracks_form','tracks[]',0);return false;\">&minus;</button>
</td>
<td class='tbl2' align='center'>
<input type='submit' class='button' name='generate' value='".$locale['mbp210']."'>
<input type='submit' class='button' name='edit' value='".$locale['mbp211']."'>
<input type='submit' class='button' name='delete' value='".$locale['mbp212']."'>
</td>
<td class='tbl2' align='center'><span class='small2'>[<a href='".FUSION_SELF.$aidlink."&amp;step=refresh"."' title='".$locale['mbp213']."'>R</a>]</span></td>
</tr>
</table>
</form>\n";
} else {
 echo $locale['mbp214']."\n";
}
echo "</center>\n";
closetable();

tablebreak();

if (isset($_POST['edit'])){
	$tracks = array();
	foreach($_POST['tracks'] as $key => $value) $tracks[] = $_POST['tracks'][$key];
	if (count($tracks) == 0){
		redirect(FUSION_SELF.$aidlink); exit;
	}
	$result = dbquery("SELECT * FROM ".$db_prefix."musicbox_tracks WHERE track_id IN (".implode($tracks,",").") ORDER BY track_order ASC");
	if (dbrows($result)) $step = "edit";
}

if ($step == "edit"){
	$capition = $locale['mbp215'];
	$action = "&amp;step=update";
	$content = "";
	while($data = dbarray($result)){
		$content .= "<tr><td class='tbl2'>\n".generate_field($data['track_title'],$data['track_file'],$data['track_id'])."</td></tr>\n";
	}
} else {
	$capition = $locale['mbp216'];
	$action = "&amp;step=save";
	$content = "<tr><td class='tbl2'>\n".generate_field()."</td></tr>\n";
}

opentable($capition); // Dodawanie / Edycja Sciezek
echo "<center>
<form name='input_form' action='".FUSION_SELF.$aidlink.$action."' method='post'$onload>
<table cellpadding='0' cellspacing='1' class='tbl-border' width='80%'>\n";
echo $content;
echo "<tr><td class='tbl2' align='center'>
<input type='submit' class='button' value='".$locale['mbp203']."'>
<input type='reset' class='button' value='".$locale['mbp217']."'>
<input type='submit' class='button' name='cancel_button' value='".$locale['mbp218']."'>
</td></tr>
</table>
</form>
</center>\n";
closetable();

tablebreak();

// Test
echo "<center>
<table cellpadding='0' cellspacing='0' width='$theme_width_l'>
<tr>
<td>\n";
	openside($locale['mbp100']);
	echo stripslashes(nl2br($mb_settings['description']))."\n<div align='center'><button class='button' onClick='OpenMusicBox()'>".$locale['mbp301']."</button></div>\n";
	closeside();
echo "</td>
</tr>
</table>
</center>\n";

// JavaScript
echo "<script type='text/javascript' language='JavaScript'>
function setChecked(frmName,chkName,val) {
	dml=document.forms[frmName];
	len=dml.elements.length;
	for(i=0;i < len;i++) {
		if(dml.elements[i].name == chkName) {
			dml.elements[i].checked = val;
		}
	}
}
function isAnyChecked(frmName,chkName) {
	dml=document.forms[frmName];
	len=dml.elements.length;
	for(i=0;i < len;i++) {
		if(dml.elements[i].name == chkName) {
			if(dml.elements[i].checked == 1) return true;
		}
	}
	return false;
}
function OpenMusicBox(){
	window.open('".INFUSIONS."musicbox_panel/musicbox.php','MusicBox','directories=0,location=0,menubar=0,resizable=1,scrollbars=0,status=1,toolbar=0,width=300,height=300');
}
</script>\n";

function generate_field($track_title="",$track_file="",$track_id=0){
	global $locale;
	$content = "\t<table cellpadding='0' cellspacing='0' width='100%'>
	<tr>
	<td class='tbl' width='1%'>".$locale['mbp219']."</td>
	<td class='tbl'><input type='text' class='textbox' name='track_title[]' value='$track_title' style='width:300px;'></td>
	</tr>
	<tr>
	<td class='tbl' width='1%'>".$locale['mbp220']."</td>
	<td class='tbl'><input type='text' class='textbox' name='track_file[]' value='$track_file' style='width:100%;'></td>
	</tr>
	</table>\n";
	if ($track_id) $content .= "\t<input type='hidden' name='track_id[]' value='$track_id'>\n";
	return $content;
}

echo "</td>\n";
require_once BASEDIR."footer.php";
?>